﻿//////////////////////////////////////////////
// ThreadWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkTasksWrap
{
	class DLL_ASTRAEUS_EXPORT ThreadWrapper final
	{
		private :

			// Constructeur, destructeur
			ThreadWrapper () = delete ;
			~ThreadWrapper () = delete ;

		public :

			// Env
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Constructeur, destructeur
			static void* constructor (const nkScripts::DataStack& stack) ;
			static void destructor (void* toDestroy) ;
			// Threading
			static nkScripts::OutputValue addTask (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue releaseTaskRef (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue run (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue askAbort (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue join (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue askAbortAndJoin (const nkScripts::DataStack& stack) ;
			// Utils pour l'environnement
			static nkScripts::OutputValue runScript (const nkScripts::DataStack& stack) ;
	} ;
}