﻿//////////////////////////////////////////////
// ResourceSaveLoadCallback.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Node ;
}

/// Includes ---------------------------------

// nkGraphics
#include "Resource.h"

/// Class ------------------------------------

namespace nkGraphics
{
	// Le node a besoin d'une sorte de wrapper pour pouvoir le retourner en tant que ressource
	// C'est le seul dans ce cas
	class ResourceNodeWrapper : public Resource
	{
		private :

			// On wrap le node
			Node* _node ;

		public :

			// Constructeur, destructeur
			ResourceNodeWrapper () ;
			virtual ~ResourceNodeWrapper () ;

			// Overloads
			virtual bool load () override ;
			virtual void unload () override ;

			// Setters
			void setNode (Node* value) ;

			// Getters
			Node* getNode () const ;
	} ;

	// Le callback final
	class ResourceSaveLoadCallback
	{
		private :
			
			// Switch savoir le mode
			bool _loading ;

		public :
	
			// Constructeur, destructeur
			ResourceSaveLoadCallback () ;
			~ResourceSaveLoadCallback () ;

			// Setters
			void setLoading (bool value) ;

			// Getters
			bool getLoading () const ;

			// Fonctions à refaire 
			virtual void onResourceCountUpdated (unsigned int value) = 0 ;
			virtual void onResourceSuccess (Resource* resource) = 0 ;
			virtual void onResourceFail (const nkMemory::StringView& path) = 0 ;
	} ;
}