﻿//////////////////////////////////////////////
// JpgScan.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkImages
#include "JpgComponentType.h"

// nkMemory
#include <NilkinsMemory/Containers/BufferView.h>

/// Internals --------------------------------

namespace nkImages
{
	struct JpgScanComponent final
	{
		JPG_COMPONENT_TYPE _type = JPG_COMPONENT_TYPE::COMPONENT_Y ;
		unsigned char _huffmanTableIndex = 0u ;
	} ;
}

/// Class ------------------------------------

namespace nkImages
{
	class JpgScan final
	{
		public :

			// Attributes
			nkMemory::BufferView<const unsigned char> _data ;

			unsigned char _componentCount = 0u ;
			JpgScanComponent _components [3] ;

		public :

			// Functions
			// Parsing
			static JpgScan parseFromMarker (const unsigned char* data) ;
	} ;
}