﻿//////////////////////////////////////////////
// JpgBitStream.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Class ------------------------------------

namespace nkImages
{
	// Aimed at scan data, with all the specs of it implemented
	// For instance, avoiding FF[00] byte
	class JpgBitStream final
	{
		public :

			// Attributes
			// Stream & state holding
			const unsigned char* _data ;
			unsigned int _byteCounter = 0u ;
			unsigned int _bitCounter = 0u ;

		public :

			// Functions
			// Constructor
			JpgBitStream (const unsigned char* data)
			:	_data (data)
			{
				// Nothing todo
			}

			// Bit getting
			unsigned char getNextBit ()
			{
				// Get back result from right byte
				unsigned char result = (_data[_byteCounter] & (0b1 << (7 - _bitCounter))) >> (7 - _bitCounter) ;

				// Go forward, without branching
				_byteCounter += (unsigned int)((++_bitCounter / 8.f)) * (1 + _data[_byteCounter] / 255) ;
				_bitCounter %= 8 ;

				return result ;
			}

			unsigned int getNextBits (unsigned int count)
			{
				unsigned int result = 0u ;

				for (unsigned int i = 0u ; i < count ; ++i)
					result = (result << 1) + getNextBit() ;

				return result ;
			}
	} ;
}