﻿//////////////////////////////////////////////
// FontManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Font ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"
	
// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// nkMemory
#include <NilkinsMemory/Containers/StringView.h>

// Standards
#include <string>
#include <unordered_map>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT FontManager final : public nkCommon::SingletonClass<FontManager>
	{
		friend class nkCommon::SingletonClass<FontManager> ;

		private :

			// Attributes
			// Font memory
			std::unordered_map<std::string, Font*> _memory ;
			Font* _defaultFont ;

		private :

			// Functions
			// Constructor, destructor
			FontManager () ;
			~FontManager () ;
		
		public :

			// Getters
			Font* getDefaultFont () const ;
		
			// Memory management
			Font* createOrRetrieve (const nkMemory::StringView& name) ;
			Font* get (const nkMemory::StringView& name) const ;
			Font* getByIndex (unsigned int index) const ;
			void rename (const nkMemory::StringView& oldName, const nkMemory::StringView& newName) ;
			void erase (const nkMemory::StringView& name) ;
	} ;
}